<?php
declare (strict_types = 1);

namespace app\admin\model\v1;

use app\common\model\VideoBaseModel;
use think\model\concern\SoftDelete;

/**
 * 视频信息模型
 * @mixin \think\Model
 */
class VideoModel extends VideoBaseModel
{
    // 启用软删除
    use SoftDelete;
    // 软删除字段
    protected $deleteTime = 'deleted_at';

    // 关联分类
    public function category()
    {
        return $this->belongsTo(VideoCategoryModel::class, 'category_id', 'id');
    }

    // 名称搜索器
    public function searchNameAttr($query, $value, $data)
    {
        if (empty($value)) {
            return;
        }
        $query->where('name', 'like', '%' . $value . '%');
    }

    // 搜索发布时间
    public function searchCreatedAtAttr($query, $value, $data)
    {
        if (empty($value)) {
            return;
        }
        if (is_array($value)) {
            if (count($value) == 2) {
                if ($value[0] == $value[1]) {
                    $value[1] = date('Y-m-d 23:59:59', strtotime($value[1]));
                }
                $query->whereBetweenTime('created_at', $value[0], $value[1]);
            } else {
                $query->whereTime('created_at', '>=', $value[0]);
            }
        }
    }

    // 语言查询
    public function scopeLanguage($query, $value)
    {
        $query->where('language_id', '=', $value);
    }

    // 分类查询
    public function scopeCategoryId($query, $value)
    {
        if (empty($value)) {
            return;
        }
        if (is_array($value) || str_contains($value, ',')) {
            $query->whereIn('category_id', $value);
            return;
        }
        $query->where('category_id', '=', $value);
    }
}
